if not oUF then return end

local banzai = LibStub("LibBanzai-2.0")

local ignoredUnits = {
	target = true,
	targettarget = true,
	targettargettarget = true,
}

local function applyBanzai(frame, event, bar, unit, min, max)
	if not ignoredUnits[unit] and banzai:GetUnitAggroByUnitId(unit) then
		bar:SetStatusBarColor(1, 0, 0)
	end
end

for frame in pairs(oUF.objects) do
	if not frame.PostUpdateHealth then
		frame.PostUpdateHealth = applyBanzai
	else
		local o = frame.PostUpdateHealth
		frame.PostUpdateHealth = function(...)
			o(...)
			applyBanzai(...)
		end
	end
end
oUF.objects = setmetatable(oUF.objects, {__newindex = function(t, frame, v)
	if not frame.PostUpdateHealth then
		frame.PostUpdateHealth = applyBanzai
	else
		local o = frame.PostUpdateHealth
		frame.PostUpdateHealth = function(...)
			o(...)
			applyBanzai(...)
		end
	end
	rawset(t, frame, v)
end})

banzai:RegisterCallback(function(aggro, name, ...)
	for i = 1, select("#", ...) do
		local u = select(i, ...)
		if not ignoredUnits[u] and oUF.units[u] then
			if aggro == 1 then
				oUF.units[u].Health:SetStatusBarColor(1, 0, 0)
			else
				oUF.units[u]:UNIT_HEALTH(nil, u)
			end
		end
	end
end)

